{****************************
 *                          *
 * Autor: Adrian M. Hanslik *
 * Date 25. April 1999      *
 * Version: 1.0             *
 *                          *
 ****************************}

unit AMHLEDBMP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TAMHLEDBMP = class(TGraphicControl)
  private
    { Private-Deklarationen }
    fLEDActive: Boolean;
    fLEDBMPOff: TBitmap;
    fLEDBMPOn: TBitmap;
    procedure SetLEDActive(Value: Boolean);
    procedure SetLEDBMPOff(Value: TBitmap);
    procedure SetLEDBMPOn(Value: TBitmap);
  protected
    { Protected-Deklarationen }
    procedure Paint; override;
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published-Deklarationen }
    property LEDActive: Boolean read fLEDActive write SetLEDActive;
    property LEDBMPOff: TBitmap read fLEDBMPOff write SetLEDBMPOff;
    property LEDBMPOn: TBitmap read fLEDBMPOn write SetLEDBMPOn;
  end;

implementation

constructor TAMHLEDBMP.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Height := 16;
  Width := 16;
  fLEDBMPOff := TBitmap.Create;
  fLEDBMPOn := TBitmap.Create;
end;

destructor TAMHLEDBMP.Destroy;
begin
  fLEDBMPOff.Free;
  fLEDBMPOn.Free;
  inherited Destroy;
end;

procedure TAMHLEDBMP.Paint;
var
  R,s: TRect;
begin
r:=rect(0,0,fLEDBMPOn.width,fLEDBMPOn.height);
s:=rect(100,100,100+fLEDBMPOn.width,100+fLEDBMPOn.height);
  with Canvas do begin
{      SetBkMode(Canvas.Handle, TRANSPARENT);
      SetBkColor(Canvas.Handle, clWhite);}
       if fLEDActive then begin
          {Draw(0, 0, fLEDBMPOn)}
          BrushCopy(R, fLEDBMPOn, R, clOlive);
          CopyRect(s,fLEDBMPOn.canvas,r);
       end else
           {Draw(0, 0, fLEDBMPOff)}
          BrushCopy(R, fLEDBMPOff, R, clLtGray)
           end;
end;

{var
  Bitmap: TBitmap;
  MyRect, MyOther: TRect;
begin
  MyRect := Rect(10,10,100,100);
  MyOther := Rect(10,111,100, 201);
  Bitmap := TBitmap.Create;
  Bitmap.LoadFromFile('c:\windows\tartan.bmp');
  Form1.Canvas.BrushCopy(MyRect,Bitmap, MyRect, clBlack);
  Form1.Canvas.CopyRect(MyOther,Bitmap.Canvas,MyRect);
  Bitmap.Free;}

procedure TAMHLEDBMP.SetLEDActive(Value: Boolean);
begin
  if Value <> fLEDActive then begin
     fLEDActive := Value;
     Invalidate;
  end;
end;

procedure TAMHLEDBMP.SetLEDBMPOff(Value: TBitmap);
begin
  if Value <> fLEDBMPOff then begin
     fLEDBMPOff.Assign(Value);
     Invalidate;
  end;
end;

procedure TAMHLEDBMP.SetLEDBMPOn(Value: TBitmap);
begin
  if Value <> fLEDBMPOn then begin
     fLEDBMPOn.Assign(Value);
     Invalidate;
  end;
end;

end.
